﻿using ProjectRepairWork.Repositories;
using ProjectRepairWork.Entities;
using ProjectRepairWork.Repositories.Implementation;
using System.Windows.Forms;
using ProjectRepairWork.Entities.Enums;

namespace ProjectRepairWork.Forms
{
    public partial class FormCost : Form
    {

        private readonly ICostRepository _costRepository;
        private int? _costId;

        public int Id
        {
            set
            {
                try
                {
                    var premises = _costRepository.ReadCostById(value);
                    if (premises == null)
                    {
                        throw new InvalidDataException(nameof(premises));
                    }
                    numericUpDownPrice.Value = (decimal)premises.Price;
                    _costId = value;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Ошибка при получении данных", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
            }
        }

        public FormCost(ICostRepository costRepository)
        {
            InitializeComponent();
            _costRepository = costRepository ?? throw new ArgumentNullException(nameof(costRepository));

        }


        


        private void ButtonSave_Click(object sender, EventArgs e)
        {
            try
            {
                if (numericUpDownPrice.Value == 0)
                {
                    throw new Exception("Имеются незаполненные поля");
                }

                if (_costId.HasValue)
                {
                    _costRepository.UpdateCost(CreateCost(_costId.Value));
                }
                else
                {
                    _costRepository.CreateCost(CreateCost(0));
                }

                Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при сохранении", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        private Cost CreateCost(int id) => Cost.CreatEntity(
       id, Convert.ToInt32(numericUpDownPrice.Value));
        private void ButtonCancel_Click(object sender, EventArgs e) => Close();
        

        
    }
}
