using Unity;
using ProjectRepairWork.Repositories;
using ProjectRepairWork.Repositories.Implementation;
using Unity.Lifetime;
namespace ProjectRepairWork
{
    internal static class Program
    {
        /// <summary>
        ///  The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            // To customize application configuration such as set high DPI settings or default font,
            // see https://aka.ms/applicationconfiguration.
            ApplicationConfiguration.Initialize();
            Application.Run(CreateContainer().Resolve<FormRepairWork>());
        }
        private static IUnityContainer CreateContainer()
        {
            var container = new UnityContainer();
            container.RegisterType<ICostRepository, CostRepository>(new TransientLifetimeManager());
            container.RegisterType<IContractorsRepository, ContractorsRepository>(new TransientLifetimeManager());
            container.RegisterType<IPremisesRepository, PremisesRepository>(new TransientLifetimeManager());
            container.RegisterType<IRepairRepository, RepairRepository>(new TransientLifetimeManager());
            container.RegisterType<IWorksRepository, WorksRepository>(new TransientLifetimeManager());
            return container;
        }

    }
}